<?php
/*************************************************************
*www.softiran.org
**************************************************************/

class osC_Payment_mabna extends osC_Payment {
	var $_title, $_code = 'mabna', $_status = false, $_sort_order, $_order_id;

	function osC_Payment_mabna() {
		global $osC_Database, $osC_Language, $osC_ShoppingCart;
		$this->_title = $osC_Language->get('درگاه پرداخت شرکت مبنا کارت');
		$this->_method_title = $osC_Language->get('درگاه پرداخت شرکت مبنا کارت');
		$this->_status = (MODULE_PAYMENT_MABNA_STATUS == '1') ? true : false;
		$this->_sort_order = MODULE_PAYMENT_MABNA_SORT_ORDER;
		$this->form_action_url = 'https://mabna.shaparak.ir';
		
		if ($this->_status === true) {
			if ((int) MODULE_PAYMENT_MABNA_ORDER_STATUS_ID > 0) {
				$this->order_status = MODULE_PAYMENT_MABNA_ORDER_STATUS_ID;
			}
			if ((int) MODULE_PAYMENT_MABNA_ZONE > 0) {
				$check_flag = false;
				$Qcheck = $osC_Database->query('select zone_id from :table_zones_to_geo_zones where geo_zone_id = :geo_zone_id and zone_country_id = :zone_country_id order by zone_id');
				$Qcheck->bindTable(':table_zones_to_geo_zones', TABLE_ZONES_TO_GEO_ZONES);
				$Qcheck->bindInt(':geo_zone_id', MODULE_PAYMENT_MABNA_ZONE);
				$Qcheck->bindInt(':zone_country_id', $osC_ShoppingCart->getBillingAddress('country_id'));
				$Qcheck->execute();
				while ($Qcheck->next()) {
					if ($Qcheck->valueInt('zone_id') < 1) {
						$check_flag = true;
						break;
					}
					elseif ($Qcheck->valueInt('zone_id') == $osC_ShoppingCart->getBillingAddress('zone_id')) {
						$check_flag = true;
						break;
					}
				}
				if ($check_flag === false) {
					$this->_status = false;
				}
			}
		}
	}
	function selection() {
		return array('id' => $this->_code, 'module' => $this->_method_title);
	}
	function pre_confirmation_check() {
		return false;
	}
	function confirmation() {
		global $osC_Language, $osC_CreditCard;
		$this->_order_id = osC_Order :: insert(ORDERS_STATUS_PREPARING);
		$confirmation = array('title' => $this->_method_title, 'fields' => array(array('title' => $osC_Language->get('درگاه شرکت مبنا کارت'))));
		return $confirmation;
	}
	function process_button() {
		global $osC_Currencies, $osC_ShoppingCart, $osC_Language, $osC_Database;
		if (MODULE_PAYMENT_MABNA_CURRENCY == 'Selected Currency') {
			$currency = $osC_Currencies->getCode();
		}
		else {
			$currency = MODULE_PAYMENT_MABNA_CURRENCY;
		}
		$amount = round($osC_Currencies->formatRaw($osC_ShoppingCart->getTotal(), $currency), 2);
		$order = $this->_order_id;
		$status = 1;
		$redirectAddress = (osc_href_link(FILENAME_CHECKOUT, 'process', 'HTTP', null, null, true));
		
		$merchant = trim(MODULE_PAYMENT_MABNA_PIN);
		$terminal = trim(MODULE_PAYMENT_MABNA_TER);
		
		$pat = dirname(__FILE__);
		if(!function_exists('timestamp_to_iso8601'))
		{
			include_once $pat . '/nusoap2.php';
		}
		
		$invoiceNumber = time();
		$source = $amount . $invoiceNumber . $merchant . $redirectAddress . $terminal;

		$fp = fopen($pat . '/../../../public.txt', "r");
		$pub_key = fread($fp, 8192);
		fclose($fp);
		if (strpos($pub_key, '-----BEGIN PUBLIC KEY-----') === false)
			$pub_key = "-----BEGIN PUBLIC KEY-----\n" . $pub_key;

		if (strpos($pub_key, '-----END PUBLIC KEY-----') === false)
			$pub_key .= "\n-----END PUBLIC KEY-----";


		// Amount
		$key_resource = openssl_get_publickey($pub_key);

		openssl_public_encrypt($amount, $crypttext, $key_resource);

		$Amount = base64_encode($crypttext);
		// CRN

		openssl_public_encrypt($invoiceNumber, $crypttext, $key_resource);
		$CRN = base64_encode($crypttext);

		// MID
		openssl_public_encrypt($merchant, $crypttext, $key_resource);
		$MID = base64_encode($crypttext);

		// TID
		openssl_public_encrypt($terminal, $crypttext, $key_resource);
		$TID = base64_encode($crypttext);

		// redirectAddress
		openssl_public_encrypt($redirectAddress, $crypttext, $key_resource);
		$referal = base64_encode($crypttext);

		$key = file_get_contents($pat . '/../../../private.txt');

		if (strpos($key, '-----BEGIN PRIVATE KEY-----') === false)
			$key = "-----BEGIN PRIVATE KEY-----\n" . $key;

		if (strpos($key, '-----END PRIVATE KEY-----') === false)
			$key .= "\n-----END PRIVATE KEY-----";

		$priv_key = openssl_pkey_get_private($key);
		$signature = '';
		openssl_sign($source, $signature, $priv_key, OPENSSL_ALGO_SHA1);
		$inputArray = array("Token_param" => array("AMOUNT" => $Amount,
			"CRN" => $CRN,
			"MID" => $MID,
			"REFERALADRESS" => $referal,
			"SIGNATURE" => base64_encode($signature),
			"TID" => $TID,
		));


		$__SOAP = "https://mabna.shaparak.ir/TokenService?wsdl";
		$client = new nusoap_client($__SOAP, 'wsdl');
		$WSResult = $client->call("reservation", $inputArray);
		$signature = base64_decode($WSResult['return']['signature']);
		$ok = openssl_verify($WSResult['return']['token'], $signature, $key_resource);

		openssl_free_key($key_resource);
		
		if ($ok == 1 && $WSResult['return']['result'] == 0) 
		{
			@session_start();
			$_SESSION['order'] =$order ;
			$token = $WSResult['return']['token'];
			$osC_Database->simpleQuery("insert into `" . DB_TABLE_PREFIX . "online_transactions`(orders_id,receipt_id,transaction_method,transaction_date,transaction_amount,transaction_id) values('$order','$token','mabna','','$amount','')");
			$process_button_string = osc_draw_hidden_field('TOKEN', $token);
			return $process_button_string;
		}
		else 
		{
			osC_Order :: remove($this->_order_id);
			echo '<div style="font-size:11px; color:#cc0000; width:500; border:1px solid #cc0000; padding:5px; background:#ffffcc;">خطا در ساخت توکن : ' . $WSResult['return']['token'] . '</div>';
		}
		

	}
	function get_error() {
		global $osC_Language;
		return $error;
	}
	function process() 
	{
		global $osC_Language, $osC_Customer,$osC_Currencies, $osC_ShoppingCart, $_POST, $_GET, $messageStack, $osC_Database;
		@session_start();
		$invoiceid = isset($_SESSION['order']) ? $_SESSION['order'] : 0;
		$amount = round($osC_Currencies->formatRaw($osC_ShoppingCart->getTotal(), $currency), 2);

		if( isset($_POST['CRN']) && isset($_POST['TRN']) && isset($_POST['RESCODE']) && $_POST['RESCODE'] == '00' )
		{

			$pat = dirname(__FILE__);
			if(!function_exists('timestamp_to_iso8601'))
			{
				include_once $pat . '/nusoap2.php';
			}
			
			$merchant = trim(MODULE_PAYMENT_MABNA_PIN);
			
			$client = new nusoap_client("https://mabna.shaparak.ir/TransactionReference/TransactionReference?wsdl", 'wsdl');
			$error = $client->getError();
			
			$fp = fopen($pat . '/../../../public.txt', "r");
			$pub_key = fread($fp, 8192);
			fclose($fp);
			if (strpos($pub_key, '-----BEGIN PUBLIC KEY-----') === false)
				$pub_key = "-----BEGIN PUBLIC KEY-----\n" . $pub_key;

			if (strpos($pub_key, '-----END PUBLIC KEY-----') === false)
				$pub_key .= "\n-----END PUBLIC KEY-----";

			$key_resource = openssl_get_publickey($pub_key);

			openssl_public_encrypt($_POST["TRN"], $crypttext, $key_resource );
			$TRN = base64_encode($crypttext);

			// CRN
			openssl_public_encrypt($_POST["CRN"], $crypttext, $key_resource );
			$CRN = base64_encode($crypttext);

			// MID
			openssl_public_encrypt($merchant, $crypttext, $key_resource );
			$MID = base64_encode($crypttext);

			// Sign data
			$source = $merchant.$_POST["TRN"].$_POST["CRN"];
			
			$key = file_get_contents($pat . '/../../../private.txt');

			if (strpos($key, '-----BEGIN PRIVATE KEY-----') === false)
				$key = "-----BEGIN PRIVATE KEY-----\n" . $key;

			if (strpos($key, '-----END PRIVATE KEY-----') === false)
				$key .= "\n-----END PRIVATE KEY-----";
		
			$priv_key = openssl_pkey_get_private($key);
			$signature = '';
			openssl_sign($source, $signature, $priv_key, OPENSSL_ALGO_SHA1);
			$inputArray = array("SaleConf_req" => array("MID"    => $MID,
														"CRN"    => $CRN,
														"TRN"    => $TRN,
														"SIGNATURE" => base64_encode($signature)));
			$WSResult = $client->call("sendConfirmation", $inputArray);
			$error = $client->getError();
			$signature = base64_decode($WSResult["return"]["SIGNATURE"]);
			$data2      = $WSResult["return"]["RESCODE"].$WSResult["return"]["REPETETIVE"].$WSResult["return"]["AMOUNT"].$WSResult["return"]["DATE"].$WSResult["return"]["TIME"].$WSResult["return"]["TRN"].$WSResult["return"]["STAN"];

			$ok = openssl_verify($data2, $signature, $key_resource);
			if ($ok == 1) 
			{
				 if (($WSResult['return']['RESCODE'] == '00') && ($WSResult['return']['successful'] == true)) 
				 {
					 if(floatval($WSResult["return"]["AMOUNT"])  == floatval($amount))
					{
						$referenceId = $WSResult["return"]["TRN"];
						
						$osC_Database->simpleQuery("update `" . DB_TABLE_PREFIX . "online_transactions` set transaction_id = '$referenceId',transaction_date = '" . date("YmdHis") . "' where  orders_id = '$invoiceid' ");
						$Qtransaction = $osC_Database->query('insert into :table_orders_transactions_history (orders_id, transaction_code, transaction_return_value, transaction_return_status, date_added) values (:orders_id, :transaction_code, :transaction_return_value, :transaction_return_status, now())');
						$Qtransaction->bindTable(':table_orders_transactions_history', TABLE_ORDERS_TRANSACTIONS_HISTORY);
						$Qtransaction->bindInt(':orders_id', $invoiceid);
						$Qtransaction->bindInt(':transaction_code', 1);
						$Qtransaction->bindValue(':transaction_return_value', $referenceId);
						$Qtransaction->bindInt(':transaction_return_status', 1);
						$Qtransaction->execute();
						$this->_order_id = osC_Order :: insert();
						$comments = $osC_Language->get(' کدارجاع : ') .$referenceId.$osC_Language->get(' سفارش با شناسه : '). $invoiceid;
						osC_Order :: process($this->_order_id, $this->order_status, $comments);
					}
					else 
					{
						$order = $this->_order_id;
						$orderid = $order;
						$reversaltoreversal = $order;
						$reversalstatus = 1;
						$osC_Database->simpleQuery("delete from `" . DB_TABLE_PREFIX . "online_transactions` where 1  ( orders_id = '$order' )");
						osC_Order :: remove($this->_order_id);
						$messageStack->add_session('checkout', 'خطا !!! مبلغ واریزی با مبلغ کالا برابر نیست.', 'error');
						osc_redirect(osc_href_link(FILENAME_CHECKOUT, 'checkout&view=paymentInformationForm', 'SSL', null, null, true));
					}
				 }
				 else 
				{
					$order = $this->_order_id;
					$orderid = $order;
					$reversaltoreversal = $order;
					$reversalstatus = 1;
					$osC_Database->simpleQuery("delete from `" . DB_TABLE_PREFIX . "online_transactions` where 1  ( orders_id = '$order' )");
					osC_Order :: remove($this->_order_id);
					$messageStack->add_session('checkout', 'تراکنش قبلا پرداخت شده است.', 'error');
					osc_redirect(osc_href_link(FILENAME_CHECKOUT, 'checkout&view=paymentInformationForm', 'SSL', null, null, true));
				}
			}
			else 
			{
				$order = $this->_order_id;
				$orderid = $order;
				$reversaltoreversal = $order;
				$reversalstatus = 1;
				$osC_Database->simpleQuery("delete from `" . DB_TABLE_PREFIX . "online_transactions` where 1  ( orders_id = '$order' )");
				osC_Order :: remove($this->_order_id);
				$messageStack->add_session('checkout', 'خطا در وریفای اطلاعات.', 'error');
				osc_redirect(osc_href_link(FILENAME_CHECKOUT, 'checkout&view=paymentInformationForm', 'SSL', null, null, true));
			}
				
			
			
		}
		else {
	        $order = $this->_order_id;
			$orderid = $order;
			$reversaltoreversal = $order;
			$reversalstatus = 1;
			$osC_Database->simpleQuery("delete from `" . DB_TABLE_PREFIX . "online_transactions` where 1  ( orders_id = '$order' )");
			osC_Order :: remove($this->_order_id);
			$errorname = 'برگشت ناموفق از درگاه';
			$messageStack->add_session('checkout', 'در عملیات پرداخت خطا رخ داده است : <b>'.$errorname.'</b>' , 'error');
			osc_redirect(osc_href_link(FILENAME_CHECKOUT, 'checkout&view=paymentInformationForm', 'SSL', null, null, true));
		    }
	}

	function callback() {
		global $osC_Database;
		//
	}

}
?>